NAV Navbar
shell javascript

Introduction

Welcome to the Seven Time API! You can use our API to access Seven Time API endpoints.

You can view code examples for Shell and JavaScript in the dark area to the right, and you can switch the programming language of the examples with the tabs in the top right.

Authentication

To authorize, use this code:

# With shell, you can just pass the correct header with each request
curl "api_endpoint_here" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Send Client-Secret in the header. Sample with the request library */

let options = {
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  // ....
});

Make sure to replace thisismysecretkey with your API key.

Seven Time uses API keys to allow access to the API. You can get a new Seven Time API key in "Settings -> Integrations -> API" in Seven Time.

Seven Time expects the API key to be included in all API requests to the server in a header that looks like the following:

Client-Secret: thisismysecretkey

Header fields

In addition to the 'Client-Secret', a few fields are required in the Header:

Actions

The Seven Time API supports four different actions:

Pagination

Searches that returns a large number of results are paged due to performance reasons.

These searches are limited by the parameter 'limit'. This parameter limits the number of results that will be returned. By default (if not specified), this limit is set to 100 but can be set as low as 1 and as high as 500.

When the number of results exceed the given limit, the 'page' parameter can be used to retrieve different intervals in the data. By default (if not specified), this value is set to 1.

Example of 'limit' and 'page'

A search returns 490 results and the limit is set to 100. To get the first 100 results, the parameter 'page' is set to 1. To get the next 100 results, 'page' is set to 2, etc.

The data returned will be in the form of a JSON and contain a meta property where you will find information about the total number of results, number of pages and the current page. The data property contains the information requested.

For time logs, expenses, invoices, machine time logs, driver journals, purchase orders and work orders, the count is capped at 2000 for performance reasons, and the meta property contains some additional fields:

Some of these endpoints (driver journals, expenses, machine time logs and purchase orders) return HTTP 422 if no filter is given.

{
  "meta": {
    "totalResources": 490,
    "totalPages": 5,
    "currentPage": 2
  },
  "data": [
    {
      // ...
    },
    {
      // ...
    }
  ]
}

Rate-limit

When the number of requests reach the rate limit the HTTP 429 (Too Many Requests) is returned. The production limit is 4 requests per second. This equals to a bit more than 200 requests per minute.

Errors

The Seven Time API uses the following error codes:

Error Code Meaning
400 Bad Request -- Your request is invalid, e.g. a required field is missing, a parameter has an invalid value, or the 'Content-Type' header is not 'application/json' on a non-GET request.
401 Unauthorized -- Your API key is wrong, or the user connected to a personal API key is no longer active.
403 Forbidden -- The API key (or the user connected to a personal API key) does not have permission to access the resource.
404 Not Found -- The specified resource could not be found.
422 Unprocessable Entity -- The list query has no filters and could match a very large number of records (code: "QUERY_TOO_BROAD"). Add a filter, e.g. a date range.
429 Too Many Requests -- The rate limit has been exceeded. See 'Rate-limit'.
500 Internal Server Error -- We had a problem with our server. Note that many validation errors that occur when creating or updating a resource are also returned with HTTP 500 and a descriptive errorMessage.
503 Service Unavailable -- We're temporarily offline for maintenance. Please try again later.

When applicable the error message will be available in the response as errorMessage.

Analytics

The analytics endpoints return aggregated data, e.g. hours per customer and month or invoiced amount per project, without having to fetch and sum every single object.

All analytics endpoints work the same way. You send a POST request with a JSON body that specifies a date range, what to group by and which metrics to calculate. The available groupings, metrics, date fields and filters differ per resource and are listed under each endpoint below.

Get Time Log Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/timeLogs" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-03-31","groupBy":["customer","month"],"metrics":["hours","revenue"],"sort":{"metric":"hours","direction":"desc"},"limit":20}'
let jsonData = {
  fromDate: '2024-01-01',
  toDate: '2024-03-31',
  groupBy: ['customer', 'month'],
  metrics: ['hours', 'revenue'],
  sort: {
    metric: 'hours',
    direction: 'desc'
  },
  limit: 20
};

let options = {
  url: 'https://app.seventime.se/api/2/analytics/timeLogs',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
  } else {
    console.error("ERROR! Unable to get time log analytics: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "data": [
    {
      "group": {
        "customer": "5bae34dca878b5497748",
        "customerName": "Kund AB",
        "year": 2024,
        "month": 2
      },
      "hours": 124.5,
      "revenue": 99600
    },
    {
      "group": {
        "customer": "5bae34dca878b5497749",
        "customerName": "Bygg AB",
        "year": 2024,
        "month": 1
      },
      "hours": 88,
      "revenue": 70400
    }
  ],
  "meta": {
    "groupBy": ["customer", "month"],
    "dateField": "timestamp",
    "groupCount": 2,
    "limit": 20,
    "currentPage": 1,
    "hasMore": false,
    "nextPage": null
  }
}

This endpoint returns aggregated time logs.

HTTP Request

POST https://app.seventime.se/api/2/analytics/timeLogs

POST Parameters

These parameters are the same for all analytics endpoints.

Parameter Type Required? Description
fromDate String Yes Start of the date range, in the format 'YYYY-MM-DD'
toDate String Yes End of the date range (inclusive), in the format 'YYYY-MM-DD'. The date range can be at most 5 years
groupBy String or Array Yes What to group by. Either a single value, e.g. "customer", or an array of up to two different values, e.g. ["customer", "month"]
metrics Array Yes The metrics to calculate for each group, e.g. ["hours", "revenue"]
dateField String No The date field that fromDate/toDate and the date groupings (day, week, month, year) are based on. Defaults to the first value listed for each endpoint
filters Object No Filters that limit which objects are included. See each endpoint for available filters
sort Object No metric: one of the requested metrics, defaults to the first one. direction: "asc" or "desc", defaults to "desc"
limit Number No Number of groups per page. Default 20, maximum 500
page Number No Page number. Default 1

Response

Each object in data contains group, which describes the group, and one field per requested metric. group contains the ids and names for the requested groupings:

groupBy Fields in group
day date ('YYYY-MM-DD')
week year, week (ISO week)
month year, month
year year
status status (status code)

Other groupings return the id of the object together with its name, e.g. customer and customerName.

Use meta.hasMore and meta.nextPage to fetch the next page.

Invalid parameters, e.g. an unknown metric or grouping, a missing date range or an invalid id in filters, return HTTP status 400 with an errorMessage describing the error.

Time logs

Option Values
dateField timestamp, createDate
groupBy customer, project, user, activity (time category), day, week, month, year
metrics hours, billableHours, nonBillableHours, cost, revenue, logCount
Filter Description
customerId Id of a customer
projectId Id of a project
userId Id of a user
activityId Id of a time category

Get Invoice Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/invoices" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"month","metrics":["netAmount","invoiceCount"]}'

This endpoint returns aggregated invoices. See Get Time Log Analytics for the request and response format.

Draft, obliterated and customer loss invoices (status 1, 4 and 7) are excluded unless filters.status is specified. Credit invoices are subtracted from the amounts.

HTTP Request

POST https://app.seventime.se/api/2/analytics/invoices

Option Values
dateField invoiceDate, sentDate, createDate
groupBy customer, project, month, year, status
metrics netAmount (excl. tax), grossAmount (incl. tax), taxAmount, invoiceCount
Filter Description
customerId Id of a customer
projectId Id of a project
status Invoice status, 1-7. Only invoices with this status are included

Get Expense Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/expenses" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"expenseItem","metrics":["quantity","revenue"]}'

This endpoint returns aggregated expenses. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/expenses

Option Values
dateField timestamp, createDate
groupBy customer, project, user, expenseItem, day, week, month, year
metrics cost, revenue, quantity, expenseCount
Filter Description
customerId Id of a customer
projectId Id of a project
userId Id of a user
expenseItemId Id of an expense item

Get Machine Time Log Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/machineTimeLogs" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":["machine","month"],"metrics":["hours"]}'

This endpoint returns aggregated machine time logs. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/machineTimeLogs

Option Values
dateField timestamp, createDate
groupBy machine, customer, project, user, day, week, month, year
metrics hours, billableHours, nonBillableHours, cost, revenue, logCount
Filter Description
customerId Id of a customer
projectId Id of a project
userId Id of a user
machineId Id of a machine

Get Driver Journal Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/driverJournals" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"vehicle","metrics":["distance","tripCount"]}'

This endpoint returns aggregated driver journals. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/driverJournals

Option Values
dateField timestamp, createDate
groupBy user, customer, project, vehicle, day, week, month, year
metrics distance, cost, revenue, tripCount
Filter Description
customerId Id of a customer
projectId Id of a project
userId Id of a user
vehicleId Id of a vehicle

Get Supplier Invoice Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/supplierInvoices" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"distributor","metrics":["netAmount"]}'

This endpoint returns aggregated supplier invoices. See Get Time Log Analytics for the request and response format.

Obliterated supplier invoices (status 35) are excluded unless filters.status is specified. Credit invoices are subtracted from the amounts.

HTTP Request

POST https://app.seventime.se/api/2/analytics/supplierInvoices

Option Values
dateField invoiceDate, dueDate, createDate
groupBy customer, project, distributor, month, year, status
metrics netAmount (excl. tax), grossAmount (incl. tax), taxAmount, invoiceCount
Filter Description
customerId Id of a customer
projectId Id of a project
distributorId Id of a distributor
status Supplier invoice status: 1 (Registered), 5 (Draft), 7 (Sent), 10 (Invoiced), 15 (Attest pending), 35 (Obliterated) or 50 (Paused)

Get Work Order Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/workOrders" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":["workOrderType","month"],"metrics":["workOrderCount"]}'

This endpoint returns the number of work orders. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/workOrders

Option Values
dateField createDate, startDate
groupBy customer, project, department, workOrderType, status, month, year
metrics workOrderCount
Filter Description
customerId Id of a customer
projectId Id of a project
departmentId Id of a department
workOrderTypeId Id of a work order type
status Work order status code

Get Purchase Order Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/purchaseOrders" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"distributor","metrics":["netAmount","orderCount"]}'

This endpoint returns aggregated purchase orders. See Get Time Log Analytics for the request and response format.

Draft and obliterated purchase orders (status 1 and 3) are excluded unless filters.status is specified.

HTTP Request

POST https://app.seventime.se/api/2/analytics/purchaseOrders

Option Values
dateField purchaseOrderDate, createDate
groupBy distributor, project, status, month, year
metrics netAmount (excl. tax), grossAmount (incl. tax), cost, orderCount
Filter Description
distributorId Id of a distributor
projectId Id of a project
status Purchase order status: 1 (Draft), 2 (Sent), 3 (Obliterated), 4 (Confirmed) or 10 (Delivered)

Get Quote Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/quotes" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":["month","status"],"metrics":["quoteCount","quotedAmount"]}'

This endpoint returns aggregated quotes. See Get Time Log Analytics for the request and response format.

Draft quotes (status 1) are excluded unless filters.status is specified. To calculate e.g. a win rate, group by ["month", "status"] and compare quoteCount per status.

HTTP Request

POST https://app.seventime.se/api/2/analytics/quotes

Option Values
dateField quoteDate, sentDate, createDate
groupBy customer, project, quoteCategory, status, month, year
metrics quotedAmount (excl. tax), quotedAmountInclTax, quoteCount
Filter Description
customerId Id of a customer
projectId Id of a project
quoteCategoryId Id of a quote category
status Quote status: 1 (Draft), 2 (Sent), 3 (Accepted), 4 (Not accepted) or 10 (Opportunity)

Get Task Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/tasks" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":["user","completed"],"metrics":["taskCount"]}'

This endpoint returns the number of tasks. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/tasks

Option Values
dateField createDate, dueDate, startDate, completedDate
groupBy user, customer, project, completed, month, year
metrics taskCount
Filter Description
customerId Id of a customer
projectId Id of a project
userId Id of a user

Get Project Analytics

curl -X POST "https://app.seventime.se/api/2/analytics/projects" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"fromDate":"2024-01-01","toDate":"2024-12-31","groupBy":"projectType","metrics":["projectCount"]}'

This endpoint returns the number of projects. See Get Time Log Analytics for the request and response format.

HTTP Request

POST https://app.seventime.se/api/2/analytics/projects

Option Values
dateField createdDate, startDate, endDate, completedDate
groupBy customer, projectType, department, resultUnit, status, invoiceStatus, month, year
metrics projectCount
Filter Description
customerId Id of a customer
projectTypeId Id of a project type
departmentId Id of a department
resultUnitId Id of a result unit
status Project status code
invoiceStatus Invoice status: 0 (None), 5 (Not billable), 10 (Ready to be invoiced), 20 (Partly invoiced) or 30 (Fully invoiced)

Company Information

Get Company Information

curl "https://app.seventime.se/api/2/companyInformation/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/companyInformation/";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "id": "5171464ffbb708f33e000001",
    "companyName": "Company AB",
    "address": "Street 1",
    "zipCode": "111 22",
    "city": "Stockholm",
    "organizationNumber": "556677-8899"
  }
}

This endpoint retrieves information about the company connected to the API key.

HTTP Request

GET https://app.seventime.se/api/2/companyInformation/

URL Parameters

No parameters

If no company information is found for the account, HTTP 500 is returned with the errorMessage "Could not find company information".

Contact Persons

Get Contact Persons

curl "https://app.seventime.se/api/2/contactPersons/?limit=2&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/contactPersons/?limit=5&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 3,
    "totalPages": 1,
    "currentPage": 1
  },
  "data": [
    {
      "_id": "5fb7bcd0ab7bb01d4d54832",
      "name": "Anna",
      "title": "Utvecklare",
      "workPhone": "",
      "cellPhone": "",
      "email": "email@company.com",
      "customer": "5bb26376c4nj551167",
      "customerName": "Anna Andersson",
      "mainContact": true,
      "isActive": true,
      "createdDate": "2020-11-17T12:06:24.281Z",
      "modifiedDate": "2020-11-17T12:06:24.281Z"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves contact persons.

HTTP Request

GET https://app.seventime.se/api/2/contactPersons

Query Parameters

E.g. https://app.seventime.se/api/2/contactPersons/?customerId=5bb26376c4nj551167

Parameter Default Description
customerId The id of the customer which the contact persons belong to. If not specified, all contact persons will be retrivied, regardless of which customer they belong to
name The name of the contact persons
sortBy name If specified, a sort will be made on the specified parameter
sortDirection ascending "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending
limit 100 Number of contact persons per page. Maximum 500
page 1 Page number

Get a specific Contact Person

curl "https://app.seventime.se/api/2/contactPersons/5fb7bcd0ab7bb01d4d798762" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/contactPersons/5fb7bcd0ab7bb01d4d798762";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "_id": "5fb7bcd0ab7bb01d4d54832",
  "name": "Anna",
  "title": "Utvecklare",
  "workPhone": "",
  "cellPhone": "",
  "email": "email@company.com",
  "customer": "5bb26376c4nj551167",
  "customerName": "Anna Andersson",
  "mainContact": true,
  "isActive": true,
  "createdDate": "2020-11-17T12:06:24.281Z",
  "modifiedDate": "2020-11-17T12:06:24.281Z"
}

This endpoint retrieves a contact person. Note that the contact person is returned directly, not wrapped in a data object.

HTTP Request

GET https://app.seventime.se/api/2/contactPersons/<_id>

URL Parameters

Parameter Description
_id The _id of the contact person to retrieve

Create a Contact Person

curl -X POST "https://app.seventime.se/api/2/contactPersons/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"customer":"5f48eb712ebe7ebe6eb37b","name":"Anna Andersson","title":"Chef","workPhone":"","cellPhone":"","email":"email@company.com","isActive":"true","mainContact":"false"}'
let jsonData = {
  customer: '5f48eb712ebe7ebe6eb37b',
  name: 'Anna Andersson',
  title: 'Utvecklare',
  workPhone: '',
  cellPhone: '',
  email: 'email@company.com',
  isActive: true,
  mainContact: false
};

let options = {
  url: 'https://app.seventime.se/api/2/contactPersons',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
  } else {
    console.error("ERROR! Unable to create contact person: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "5fb7bcd0ab7bb01d4d54832",
  "name": "Anna",
  "title": "Utvecklare",
  "workPhone": "",
  "cellPhone": "",
  "email": "email@company.com",
  "customer": "5bb26376c4nj551167",
  "customerName": "Anna Andersson",
  "mainContact": true,
  "isActive": true,
  "createdDate": "2020-11-17T12:06:24.281Z",
  "modifiedDate": "2020-11-17T12:06:24.281Z"
}

This endpoint creates a contact person.

HTTP Request

POST https://app.seventime.se/api/2/contactPersons/

POST Parameters

Parameter Type Required? Description
customer String Yes Id of the customer that the contact person will belong to
name String Yes Name of the contact person
title String No Title
workPhone String No Work phone
cellPhone String No Cell phone
email String No Email
isActive Boolean No Is the contact person active? Default true
mainContact Boolean No Main contact. Default false

Update a Contact person

curl -X PUT "https://app.seventime.se/api/2/contactPersons/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"571f61330c7f498a4712448b","isActive":"false"}' 
let jsonData = {
  _id: '571f61330c7f498a4712448b',
  isActive: false
};

let options = {
  url: 'https://app.seventime.se/api/2/contactPersons',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Contact person updated: " + body.name + ", _id: " + body._id);

  } else {
    console.error("ERROR! Unable to update contact person: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "5fb7bcd0ab7bb01d4d54832",
  "name": "Anna",
  "title": "Utvecklare",
  "workPhone": "",
  "cellPhone": "",
  "email": "email@company.com",
  "customer": "5bb26376c4nj551167",
  "customerName": "Anna Andersson",
  "mainContact": true,
  "isActive": true,
  "createdDate": "2020-11-17T12:06:24.281Z",
  "modifiedDate": "2020-11-17T12:06:24.281Z"
}
"Contact person updated: Anna, _id: 5fb7bcd0ab7bb01d4d54832"

This endpoint updates a contact person.

HTTP Request

PUT https://app.seventime.se/api/2/contactPersons/

PUT Parameters

The table below shows the required fields. Other available fields can be found in the section 'Create a Contact Person'. Empty values for name, title, workPhone, cellPhone and email are ignored, so these fields cannot be cleared through the API.

Parameter Type Required? Description
_id String Yes Id of the contact person

Customers

Get Customers

curl "https://app.seventime.se/api/2/customers/?limit=10&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/customers/?limit=10&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 33,
    "totalPages": 4,
    "currentPage": 2
  },
  "data": [
    {
      "_id": "571f61330c7f498a2d5812",
      "customerNumber": "733352",
      "vatNumber": "SE555708197354",
      "organizationNumber": "555555-5555",
      "email": "email@company.com",
      "phone": "1234-123456",
      "city": "Stockholm",
      "zipCode": "123 45",
      "address": "Östra Gatan 129",
      "name": "Anna Andersson",
      "documents": [],
      "billingSettings": {
        "useSeparateBillingAddress": false,
        "address": "",
        "address2": "",
        "zipCode": "",
        "city": "",
        "useSeparateBillingEmail": false,
        "invoiceEmail": "",
        "invoiceDeliveryType": 0,
        "defaultEmailSubject": "",
        "isConstructionCompany": false,
        "isROTCustomer": true,
        "isRUTCustomer": false,
        "typeOfProperty": 1,
        "propertyDescription": "",
        "housingSocietyNumber": "",
        "apartmentNumber": "",
        "personalNumber": "",
        "deductionDistribution": [
          {
            "itemId": "0.40862768612862976",
            "userName": "Anna Andersson",
            "personalNumber": "555555-5555",
            "distributionPercent": 100,
            "_id": "5bb2683d3a0f154899"
          }
        ],
        "expenseDiscount": 0,
        "expenseCustomProfitMargin": 0,
        "markupPercentSupplierInvoice": -1000,
        "priceList": null,
        "priceListName": ""
      },
      "modifiedDate": "2018-10-01T18:12:06.025Z",
      "createdDate": "2018-10-01T18:12:06.025Z",
      "address2": "",
      "country": "",
      "billingMethod": "",
      "pricePerHour": 0,
      "paymentDays": 20,
      "notes": "",
      "isActive": true
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves customers.

HTTP Request

GET https://app.seventime.se/api/2/customers

Query Parameters

E.g. https://app.seventime.se/api/2/customers/?limit=10&page=1&organizationNumber=555555-5555

Parameter Default Description
name If specified, customers that match the parameter will be included.
customerNumber If specified, customers that match the parameter will be included.
organizationNumber If specified, customers that match the parameter will be included.
city If specified, customers that match the parameter will be included.
email If specified, customers that match the parameter will be included.
lastModified If specified, customers that has been modified since the specified timestamp will be included. Accepted formats: 'YYYY-MM-HH HH:MM', 'YYYY-MM-HH HH:MM:SS', 'YYYY-MM-HHTHH:MM', 'YYYY-MM-HHTHH:MM:SS'
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending
limit 100 Number of customers per page. Maximum 500
page 1 Page number

Get a specific Customer

curl "https://app.seventime.se/api/2/customers/571f61330c7f4124592b" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/customers/571f61330c7f4124592b";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "_id": "571f61330c7f498a364892",
    "customerNumber": "733352",
    "vatNumber": "SE555702476792",
    "organizationNumber": "555555-5555",
    "email": "email@company.com",
    "phone": "1234-123456",
    "city": "Stockholm",
    "zipCode": "123 45",
    "address": "Östra Gatan 129",
    "name": "Anna Andersson",
    "documents": [],
    "billingSettings": {
      "useSeparateBillingAddress": false,
      "address": "",
      "address2": "",
      "zipCode": "",
      "city": "",
      "useSeparateBillingEmail": false,
      "invoiceEmail": "",
      "invoiceDeliveryType": 0,
      "defaultEmailSubject": "",
      "isConstructionCompany": false,
      "isROTCustomer": true,
      "isRUTCustomer": false,
      "typeOfProperty": 1,
      "propertyDescription": "",
      "housingSocietyNumber": "",
      "apartmentNumber": "",
      "personalNumber": "",
      "deductionDistribution": [
        {
          "itemId": "0.40862768612862976",
          "userName": "Anna Andersson",
          "personalNumber": "555555-5555",
          "distributionPercent": 100,
          "_id": "5bb2683d3a0fdb85133"
        }
      ],
      "expenseDiscount": 0,
      "expenseCustomProfitMargin": 0,
      "markupPercentSupplierInvoice": -1000,
      "priceList": null,
      "priceListName": ""
    },
    "modifiedDate": "2018-10-01T18:12:06.025Z",
    "createdDate": "2018-10-01T18:12:06.025Z",
    "address2": "",
    "country": "",
    "billingMethod": "",
    "pricePerHour": 0,
    "paymentDays": 20,
    "notes": "",
    "isActive": true
  }
}

This endpoint retrieves a specific customer.

HTTP Request

GET https://app.seventime.se/api/2/customers/<_id>

URL Parameters

Parameter Description
_id The _id of the customer to retrieve

Create a Customer

curl -X POST "https://app.seventime.se/api/2/customers/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"createdByUser":"5f48eb3e65d7ee8984354b","name":"Anna Andersson","address":"Östra Gatan 129","zipCode":"123 45","city":"Stockholm","phone":"1234-123456","email":"email@company.com","organizationNumber":"555555-5555"}'
let jsonData = {
  createdByUser: '5f48eb3e65d7ee8984354b',
  name: 'Anna Andersson',
  address: 'Östra Gatan 129',
  zipCode: '123 45',
  city: 'Stockholm',
  phone: '1234-123456',
  email: 'email@company.com',
  organizationNumber: '555555-5555'
};

let options = {
  url: 'https://app.seventime.se/api/2/customers',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
  } else {
    console.error("ERROR! Unable to create customer: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "571f61330c7f498a4712448b",
  "customerNumber": "733352",
  "organizationNumber": "555555-5555",
  "email": "email@company.com",
  "phone": "1234-123456",
  "city": "Stockholm",
  "zipCode": "123 45",
  "address": "Östra Gatan 129",
  "name": "Anna Andersson",
  "documents": [],
  "billingSettings": {
    "deductionDistribution": []
  },
  "modifiedDate": "2018-10-01T18:12:06.025Z",
  "createdDate": "2018-10-01T18:12:06.025Z",
  "isActive": true
}

This endpoint creates a customer.

HTTP Request

POST https://app.seventime.se/api/2/customers/

POST Parameters

Parameter Type Required? Description
createdByUser String Yes Id of the user who created the customer
name String Yes Name of the customer
customerNumber String No Customer number. If specified it has to be unique otherwise an error will be returned. If not specified it will be set automatically.
typeOfCustomer Number No Type of customer. 10 for company, 20 for private. If not specified or invalid, this will be set to 10
address String No Address
address2 String No Address 2
zipCode String No Zip code
city String No City
country String No Country code
phone String No Phone number
email String No Email address
organizationNumber String No Organization number or Personal number
vatNumber String No VAT number
paymentDays Number No Payment days for the customer. If not specified, this will be set to 30
notes String No Notes
deliveryAddress Object No Contains attributes specific for delivery. See below for details.
billingSettings Object No Contains attributes specific for billing. See below for details.

Attributes for deliveryAddress

Parameter Type Required? Description
name String No Name on delivery address
address String No Primary delivery address
address2 String No Secondary delivery address
zipCode String No Zip code
city String No City
country String No Country
phone String No Phone number

Attributes for billingSettings

Parameter Type Required? Description
useSeparateBillingAddress Boolean No Should an alternative billing address be used?
address String No Used if useSeparateBillingAddress is true
address2 String No Used if useSeparateBillingAddress is true
zipCode String No Used if useSeparateBillingAddress is true
city String No Used if useSeparateBillingAddress is true
useSeparateBillingEmail Boolean No If 'invoiceEmail' should be used
invoiceEmail String No Used for invoices if useSeparateBillingEmail is true
invoiceDeliveryType Number No Empty or 0 = Email, 10 = Postal letter, 20 = Svefaktura. Ignored when creating a customer, can only be set when updating
defaultEmailSubject String No Default email subject for invoices. Ignored when creating a customer, can only be set when updating
isConstructionCompany Boolean No Is construction company
isROTCustomer Boolean No Is ROT customer
isRUTCustomer Boolean No Is RUT customer
typeOfProperty Number No 1 = Detached property, 2 = Condominium
propertyDescription String No Swedish: Fastighetsbeteckning
housingSocietyNumber String No Swedish: Orgnr för bostadsrättsförening
apartmentNumber String No Swedish: Lägenhetsnummer
personalNumber String No Personal number
deductionDistribution Array No Array of DeductionItem's. See below for details.

Attributes for DeductionItem

DeductionItem is used to distribute ROT / RUT work

Parameter Type Required? Description
userName String Yes Full name of person
personalNumber String Yes Personal number
distributionPercent Number Yes 1-100

Update a Customer

curl -X PUT "https://app.seventime.se/api/2/customers/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"571f61330c7f498a4712448b","modifiedByUser":"5f48eb3e65d7ee49649eeb","name":"Company AB","customerNumber":"733352"}' 
let jsonData = {
  _id: '571f61330c7f498a4712448b',
  modifiedByUser: '5f48eb3e65d7ee49649eeb',
  name: 'Company AB',
  customerNumber: '733352'
};

let options = {
  url: 'https://app.seventime.se/api/2/customers',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Customer updated: " + body.name + ", _id: " + body._id);

  } else {
    console.error("ERROR! Unable to update customer: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "571f61330c7f498a4712448b",
  "customerNumber": "733352",
  "organizationNumber": "555555-5555",
  "email": "email@company.com",
  "phone": "1234-123456",
  "city": "Stockholm",
  "zipCode": "123 45",
  "address": "Östra Gatan 129",
  "name": "Company AB",
  "documents": [],
  "billingSettings": {
    "deductionDistribution": []
  },
  "modifiedDate": "2018-10-01T18:12:06.025Z",
  "createdDate": "2018-10-01T18:12:06.025Z",
  "isActive": true  
}
"Customer updated: Company AB, _id: 571f61330c7f498a4712448b"

This endpoint updates a customer.

HTTP Request

PUT https://app.seventime.se/api/2/customers/

PUT Parameters

The table below shows the required fields. Other available fields can be found in the section 'Create a Customer'.

Parameter Type Required? Description
_id String Yes Id of the customer
modifiedByUser String Yes Id of the user who updated the customer

Custom Fields

Get Custom fields

curl "https://app.seventime.se/api/2/customFields/?entityType=200" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/customFields/?entityType=200";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "data": [
    { "_id": "572cc7advab059725982b",
      "selectFieldData": [],
      "fieldType": 100,
      "fieldName": "Kund",
      "include": true,
      "required": false
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves custom fields.

HTTP Request

GET https://app.seventime.se/api/2/customFields/?entityType=<entityType>

Query Parameters

Parameter Default Description
entityType 100 Number corresponding to entity type. See table below for available types.

If entityType is not one of the codes in the table below, HTTP 400 is returned with the errorMessage "Invalid entity type". If no field configuration exists for the entity type, HTTP 404 is returned.

The response contains all fields in the field configuration for the entity type (both standard fields and custom fields). Custom fields have fieldType 10100 (Text), 10200 (Yes/No), 10300 (Date), 10400 (Numeric), 10500 (Select list) or 10600 (Multi select list).

Entity types

Code Description
100 Time log
200 Work order
300 Tasks
400 Invoice
500 Project
600 Expense
700 Machine time log
800 Driver journal
900 Salary deviation
1000 User
1100 Customer
1200 Absence
1300 Work time absence
1400 Quote
1500 Machine
1600 Object item
1700 Customer signature
1800 Supplement order
1900 Construction diary
2000 Checklist
2100 Payment plan

Departments

Get Departments

curl "https://app.seventime.se/api/2/departments" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/departments";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 3,
    "totalPages": 1,
    "currentPage": 1
  },
  "data": [
    {
      "_id": "59d05abdc471b72e4979135",
      "name": "Utveckling",
      "departmentNumber": "2",
      "isActive": true,
      "managerIds": []
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves departments.

HTTP Request

GET https://app.seventime.se/api/2/departments

Query Parameters

E.g. https://app.seventime.se/api/2/departments/?sortBy=departmentNumber&sortDirection=descending

Parameter Default Description
sortBy name If specified, a sort will be made on the specified parameter
sortDirection ascending "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending
limit 100 Number of departments per page. Maximum 500
page 1 Page number

Get a specific Department

curl "https://app.seventime.se/api/2/departments/59d05abdc471b72e4979135" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/departments/59d05abdc471b72e4979135";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "managerIds": [],
    "_id": "59d05abdc471b72e4979135",
    "name": "Utveckling",
    "departmentNumber": "2",
    "isActive": true
  }
}

This endpoint retrieves a specific department.

HTTP Request

GET https://app.seventime.se/api/2/departments/<_id>

URL Parameters

Parameter Description
_id The _id of the department to retrieve

Distributors

Get Distributors

curl "https://app.seventime.se/api/2/distributors/?limit=5&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/distributors/?limit=5&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 16,
    "totalPages": 4,
    "currentPage": 3
  },
  "data": [
    {
      "_id": "5f6b2e6af24d5df526848",
      "name": "UE lev 20200923",
      "distributorNumber": "20",
      "address": "",
      "zipCode": "",
      "city": "",
      "country": "",
      "phone": "",
      "email": "",
      "organizationNumber": "",
      "notes": "",
      "purchaseOrderEmail": "",
      "ourCustomerNumber": "",
      "paymentDays": 30,
      "hasSelfBilling": true,
      "selfBillingSettings": {
        "invoiceDeduction": 5,
        "deductionExpenseItem": "5e74bf0917ae9b91662484d",
        "invoiceNumberSeries": "UELEV23",
        "invoiceCounter": 1,
        "emailForSelfBilling": "email@company.com"
      },
      "isActive": true,
      "isSubContractor": true,
      "createdDate": "2020-09-23T13:19:42.450Z",
      "modifiedDate": "2020-09-23T13:19:42.450Z"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves distributors.

HTTP Request

GET https://app.seventime.se/api/2/distributors

Query Parameters

Parameter Default Description
name If specified, distributors that match the parameter will be included.
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending
limit 100 Number of distributors per page. Maximum 500
page 1 Page number

Get a specific Distributor

curl "https://app.seventime.se/api/2/distributors/5f6b2e6af24d5d7121b" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/distributors/5f6b2e6af24d5d7121b";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "selfBillingSettings": {
      "invoiceDeduction": 5,
      "deductionExpenseItem": "5e74bf0917ae9b9166154952d",
      "invoiceNumberSeries": "UELEV23",
      "invoiceCounter": 1,
      "emailForSelfBilling": "email@company.com"
    },
    "_id": "5f6b2e6af24d5d7121b",
    "name": "UE lev 20200923",
    "distributorNumber": "20",
    "address": "",
    "zipCode": "",
    "city": "",
    "country": "",
    "phone": "",
    "email": "",
    "organizationNumber": "",
    "notes": "",
    "purchaseOrderEmail": "",
    "ourCustomerNumber": "",
    "paymentDays": 30,
    "hasSelfBilling": true,
    "isActive": true,
    "isSubContractor": true,
    "createdDate": "2020-09-23T13:19:42.450Z",
    "modifiedDate": "2020-09-23T13:19:42.450Z"
  }
}

This endpoint retrieves a specific distributor.

HTTP Request

GET https://app.seventime.se/api/2/distributors/<_id>

URL Parameters

Parameter Description
_id The _id of the distributor to retrieve

Get Distributor Contact Persons

curl "https://app.seventime.se/api/2/distributorContactPersons/?distributor=5f6b2e6af24d5d7121b" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/distributorContactPersons/?distributor=5f6b2e6af24d5d7121b";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "data": [
    {
      "_id": "5fca23df0317c151d15459",
      "name": "Kontaktperson 1",
      "title": "",
      "workPhone": "",
      "cellPhone": "",
      "email": "",
      "distributor": "5f6b2e6af24d5d7121b",
      "distributorName": "UE lev 20200923",
      "mainContact": false,
      "isActive": true,
      "createdDate": "2020-12-04T10:13:03.965Z",
      "modifiedDate": "2020-12-04T10:13:03.965Z"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves distributor contact persons.

HTTP Request

GET https://app.seventime.se/api/2/distributorContactPersons/?distributor=5f6b2e6af24d5d7121b

Query Parameters

Parameter Default Description
distributor Id of the distributor (24 characters). This field must be included, otherwise HTTP status 400 is returned
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending

Create a Distributor

curl -X POST "https://app.seventime.se/api/2/distributors/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"name":"DistributorName"}'
let jsonData = {
  name: 'DistributorName'
};

let options = {
  url: 'https://app.seventime.se/api/2/distributors',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
  } else {
    console.error("ERROR! Unable to create distributor: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "62f3a242ca38bbsce075249",
  "name": "Distributor Test",
  "distributorNumber": "123456",
  "address": "test 1",
  "zipCode": "12345",
  "city": "BÃ¥stad",
  "country": "SE",
  "phone": "0412412412",
  "email": "132312kewkewa",
  "organizationNumber": "12345688",
  "vatNumber": "90",
  "bankgiro": "eeee",
  "plusgiro": "bbbbb",
  "notes": "testartestar testar",
  "purchaseOrderEmail": "test@testing.com",
  "ourCustomerNumber": "031239",
  "paymentDays": 45,
  "isSubContractor": true,
  "hasSelfBilling": true,
  "selfBillingSettings": {
    "invoiceDeduction": 10,
    "invoiceNumberSeries": "SE",
    "invoiceCounter": 12,
    "emailForSelfBilling": "llllllll"
  },
  "isActive": false,
  "createdDate": "2022-08-10T12:49:26.716Z",
  "modifiedDate": "2022-08-10T12:49:26.718Z",
  "documents": [],
  "__v": 0
}

This endpoint creates a distributor

HTTP Request

POST https://app.seventime.se/api/2/distributors/

POST Parameters

Parameter Type Required? Description
name String Yes Name of the distributor. Must be unique (case insensitive), otherwise an error will be returned
distributorNumber String No Distributor number
address String No Address of the distributor
zipCode String No Zip code of the distributor
city String No City of the distributor
country String No Country of the distributor
phone String No Phone number of the distributor
webAddress String No Web address of the distributor
email String No Email of the distributor
organizationNumber String No Organization number for the distributor
vatNumber String No VAT number for the distributor
bankgiro String No Bankgiro for distributor
plusgiro String No Plusgiro for distributor
IBAN String No IBAN for distributor
BIC String No BIC for distributor
notes String No Notes
purchaseOrderEmail String No The purchase order email
ourCustomerNumber String No Your customer number for the distributor
paymentDays Number No Number of payment days
isSubContractor Boolean No Is it a sub contractor?
hasSelfBilling Boolean No Should the distributor have self billing?
selfBillingSettings Object No Object containing information about self billing. See below for more details.
isActive Boolean No Should the distributor be active?

Attributes for selfBillingSettings

Parameter Type Required? Description
invoiceDeduction Number No Invoice deduction
deductionExpenseItem String No Id of the expense item used for the deduction
invoiceNumberSeries String No Invoice number series
invoiceCounter Number No Invoice counter
emailForSelfBilling String No Email for self billing

Update a Distributor

curl -X PUT "https://app.seventime.se/api/2/distributors/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"62f3a242ca38bbsce075249","name":"New distributor name"}'
let jsonData = {
  _id: '5fbcfe75ba9312280e2145897521',
  name: 'New distributor name'
};

let options = {
  url: 'https://app.seventime.se/api/2/distributors',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Distributor updated: _id: " + body._id);
  } else {
    console.error("ERROR! Unable to update distributor: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "62f3a242ca38bbsce075249",
  "name": "New distributor name",
  "distributorNumber": "123456",
  "address": "test 1",
  "zipCode": "12345",
  "city": "BÃ¥stad",
  "country": "SE",
  "phone": "0412412412",
  "email": "132312kewkewa",
  "organizationNumber": "12345688",
  "vatNumber": "90",
  "bankgiro": "eeee",
  "plusgiro": "bbbbb",
  "notes": "testartestar testar",
  "purchaseOrderEmail": "test@testing.com",
  "ourCustomerNumber": "031239",
  "paymentDays": 45,
  "isSubContractor": true,
  "hasSelfBilling": true,
  "selfBillingSettings": {
    "invoiceDeduction": 10,
    "invoiceNumberSeries": "SE",
    "invoiceCounter": 12,
    "emailForSelfBilling": "llllllll"
  },
  "isActive": false,
  "createdDate": "2022-08-10T12:49:26.716Z",
  "modifiedDate": "2022-08-10T12:49:26.718Z",
  "documents": [],
  "__v": 0
}
"Distributor updated: _id: 62f3a242ca38bbsce075249"

This endpoint updates a distributor

HTTP Request

PUT https://app.seventime.se/api/2/distributors/

PUT Parameters

The table below shows the required fields. Other available fields can be found in the section 'Create a Distributor'.

Parameter Type Required? Description
_id String Yes Id of the distributor
name String Yes Name of the distributor. Must not be used by another distributor (case insensitive)

Documents

Get Documents

Documents are included when fetching other objects, e.g. work orders or projects. They are found in an array named documents. The objects in the array contain a path which can be used to download the documents. Folders are also included and will have the flag isFolder as true.

Documents can also be fetched directly from the Documents API. A document belongs to either:

Fetching a work order returns a documents array like this:

{
  "data": {
    "documents": [
      {
        "createDate": "2021-08-24T11:40:16.285Z",
        "modifiedDate": "2021-08-24T11:40:16.285Z",
        "_id": "6124daa00c1532914b92",
        "name": "plan1.pdf",
        "path": "https://seventimedev.s3-eu-west-1.amazonaws.com/...",
        "contentType": "application/pdf",
        "size": 20548,
        "user": "571f61330c7f498a2d5812",
        "userName": "Anna Andersson",
        "isLink": false,
        "isFolder": false,
        "folderId": "6124d18c910273b259cf819",
        "isPublic": false
      }
    ]
  }
}
curl "https://app.seventime.se/api/2/documents?entityId=5bae34dca878b5497748&entityType=200" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/documents?entityId=5bae34dca878b5497748&entityType=200";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": [
    {
      "createDate": "2021-08-24T11:40:16.285Z",
      "modifiedDate": "2021-08-24T11:40:16.285Z",
      "_id": "6124daa00c1532914b92",
      "name": "plan1.pdf",
      "path": "https://seventimedev.s3-eu-west-1.amazonaws.com/...",
      "realPath": "1234/workOrders/5bae34dca878b5497748/20210824134016/plan1.pdf",
      "contentType": "application/pdf",
      "size": 20548,
      "user": "571f61330c7f498a2d5812",
      "userName": "Anna Andersson",
      "isLink": false,
      "isFolder": false,
      "folderId": null,
      "isPublic": false
    }
  ]
}

This endpoint retrieves documents for an entity or for a document list.

HTTP Request

GET https://app.seventime.se/api/2/documents

Query Parameters

Parameter Required? Description
entityId Yes* Id of the parent object, e.g. id of a work order.
entityType Yes* Entity type of the parent. See table below for available types and corresponding code.
documentListId Yes* Id of the document list. Used for documents in the general document archive.
folderId No Folder id. Only used together with documentListId. Defaults to null, which returns documents and folders in the root of the document list.

*Either entityId + entityType or documentListId is required. They cannot be combined.

Get a specific Document

curl "https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "createDate": "2021-08-24T11:40:16.285Z",
    "modifiedDate": "2021-08-24T11:40:16.285Z",
    "_id": "6124daa00c1532914b92",
    "name": "plan1.pdf",
    "path": "https://seventimedev.s3-eu-west-1.amazonaws.com/...",
    "realPath": "1234/workOrders/5bae34dca878b5497748/20210824134016/plan1.pdf",
    "contentType": "application/pdf",
    "size": 20548,
    "user": "571f61330c7f498a2d5812",
    "userName": "Anna Andersson",
    "isLink": false,
    "isFolder": false,
    "folderId": null,
    "isPublic": false
  }
}

This endpoint retrieves a specific document. For documents attached to an entity, include entityId and entityType as query parameters. For documents in a document list, only the document id is required.

HTTP Request

GET https://app.seventime.se/api/2/documents/<_id>

URL Parameters

Parameter Description
_id The _id of the document to retrieve

Query Parameters

Parameter Required? Description
entityId Yes* Id of the parent object for documents attached to an entity.
entityType Yes* Entity type of the parent for documents attached to an entity.

*Required only when the document is attached to an entity.

Get Document Lists

curl "https://app.seventime.se/api/2/documentLists" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/documentLists";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": [
    {
      "_id": "64f1daa00c1532914b92",
      "title": "Project files",
      "createdByUser": "571f61330c7f498a2d5812",
      "createDate": "2021-08-24T11:40:16.285Z",
      "modifiedByUser": "571f61330c7f498a2d5812",
      "modifiedDate": "2021-08-24T11:40:16.285Z",
      "archived": false
    }
  ]
}

This endpoint retrieves document lists. Use the returned _id as documentListId when listing or uploading documents in the general document archive.

HTTP Request

GET https://app.seventime.se/api/2/documentLists

Upload a document

curl -X POST "https://app.seventime.se/api/2/documents/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"uploadedBy":"571f61330c7f498a2d5812","entityId":"5bae34dca878b5497748","entityType":"200","file":{"fileContent":"base64-encoded-file-content","options":{"fileName":"plan2.pdf","contentType":"application/pdf"}},"folderId":null}'
let jsonData = {
  uploadedBy: '571f61330c7f498a2d5812',
  entityId: "5bae34dca878b5497748",
  entityType: 200,
  file: {
      fileContent: data,
      options: {
          fileName: 'plan2.pdf',
          contentType: 'application/pdf'
      }
  },
  folderId: null,
};

let options = {
  url: 'https://app.seventime.se/api/2/documents',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log('File uploaded');
  } else {
    console.error("ERROR! Unable to upload document: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "success": true,
  "data": {
    "createDate": "2021-08-24T11:40:16.285Z",
    "modifiedDate": "2021-08-24T11:40:16.285Z",
    "_id": "6124daa00c1532914b92",
    "name": "plan2.pdf",
    "path": "https://seventimedev.s3-eu-west-1.amazonaws.com/...",
    "realPath": "1234/workOrders/5bae34dca878b5497748/20210824134016/plan2.pdf",
    "contentType": "application/pdf",
    "size": 20548,
    "user": "571f61330c7f498a2d5812",
    "userName": "Anna Andersson",
    "isLink": false,
    "isFolder": false,
    "folderId": null,
    "isPublic": false
  }
}

This endpoint uploads a document or adds a folder. Uploads are supported in two modes:

To create a folder, send isFolder: true. Folder uploads do not require fileContent or contentType, but file.options.fileName is still required due to the current implementation.

HTTP Request

POST https://app.seventime.se/api/2/documents/

POST Parameters

Parameter Type Required? Description
uploadedBy String Yes Id of the user who uploaded the file
entityId String Yes* Id of the parent object, e.g. id of a work order.
entityType Number Yes* Entity type of the parent. See table below for available types and corresponding code.
documentListId String Yes* Id of the document list. Used instead of entityId + entityType for the general document archive.
file Object Yes Object containing the file and information about the file. See below for more details
folderId String No Folder id in which the document will be placed. Defaults to null when omitted.
isFolder Boolean No Set to true to create a folder instead of uploading a file.

*Either entityId + entityType or documentListId is required. They cannot be combined. entityId + entityType are not required for folders when using documentListId.

Available entity types for parent object

Code Entity type
200 Work order
400 Invoice
500 Project
600 Expense
1100 Customer
1400 Quote
1500 Machine
1600 Object item
1800 Supplement order
2300 Purchase order
2400 Education log
3100 Deviation
3200 Machine log
3300 Supplier invoice

What the file object should contain

Parameter Type Required? Description
fileContent String Yes* The file content should be included here encoded as base64.
options Object Yes Options for the file. This object must contain fileName and contentType. Folder uploads currently still require file.options.fileName due to the current implementation.
fileName String Yes Name of the file in Seven Time. This does not need to be the same as the local file
contentType String Yes* Content or MIME type of the file.

*Not Required for folders

Update a document

curl -X PUT "https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"name":"updated-plan.pdf","folderId":null,"isPublic":true}'
let jsonData = {
  name: 'updated-plan.pdf',
  folderId: null,
  isPublic: true
};

let options = {
  url: 'https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log('File updated');
  } else {
    console.error("ERROR! Unable to update document: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "success": true,
  "data": {
    "createDate": "2021-08-24T11:40:16.285Z",
    "modifiedDate": "2021-08-25T09:20:40.126Z",
    "_id": "6124daa00c1532914b92",
    "name": "updated-plan.pdf",
    "path": "https://seventimedev.s3-eu-west-1.amazonaws.com/...",
    "realPath": "1234/workOrders/5bae34dca878b5497748/20210824134016/plan2.pdf",
    "contentType": "application/pdf",
    "size": 20548,
    "user": "571f61330c7f498a2d5812",
    "userName": "Anna Andersson",
    "isLink": false,
    "isFolder": false,
    "folderId": null,
    "isPublic": true
  }
}

This endpoint updates a document or folder. It can rename the document, move it to another folder, or update the public flag. For documents attached to an entity, include entityId and entityType as query parameters or in the request body. For documents in a document list, only the document id is required.

HTTP Request

PUT https://app.seventime.se/api/2/documents/<_id>

URL Parameters

Parameter Description
_id The _id of the document to update

Query Parameters

Parameter Required? Description
entityId Yes* Id of the parent object for documents attached to an entity.
entityType Yes* Entity type of the parent for documents attached to an entity.

*Required only when the document is attached to an entity. These values can also be sent in the body.

PUT Parameters

Parameter Type Required? Description
name String No New document or folder name. Cannot be empty.
folderId String No Folder id to move the document into. Send null, "null", or an empty string to move it to the root. A folder cannot be moved into itself.
isPublic Boolean No Public flag for the document.
entityId String No* Id of the parent object for documents attached to an entity.
entityType Number No* Entity type of the parent for documents attached to an entity.

*Required only when the document is attached to an entity and not sent as query parameters.

Delete a document

curl -X DELETE "https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json"
let options = {
  url: 'https://app.seventime.se/api/2/documents/6124daa00c1532914b92?entityId=5bae34dca878b5497748&entityType=200',
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.delete(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log('File deleted');
  } else {
    console.error("ERROR! Unable to delete document: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "success": true
}

This endpoint deletes a document or folder. For documents attached to an entity, include entityId and entityType as query parameters. For documents in a document list, only the document id is required. Deleting a file document also removes the stored file.

HTTP Request

DELETE https://app.seventime.se/api/2/documents/<_id>

URL Parameters

Parameter Description
_id The _id of the document to delete

Query Parameters

Parameter Required? Description
entityId Yes* Id of the parent object for documents attached to an entity.
entityType Yes* Entity type of the parent for documents attached to an entity.

*Required only when the document is attached to an entity.

Driver Journals

Get Driver Journals

curl "https://app.seventime.se/api/2/driverJournals/?fromDate=2016-06-01&toDate=2016-06-30&limit=5&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/driverJournals/?fromDate=2016-06-01&toDate=2016-06-30&limit=5&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 87,
    "totalResourcesIsExact": true,
    "totalPages": 18,
    "currentPage": 2,
    "hasMore": true,
    "nextPage": 3
  },
  "data": [
    {
      "_id": "5613c0eabed82c732b54312",
      "name": "",
      "driverJournalItemType": "574ed84219e78125333213578b",
      "driverJournalItemTypeName": "4 kr/km",
      "car": null,
      "carRegistrationNumber": "ABC123",
      "description": "",
      "user": "5f48eb3e65d7eeb491836d",
      "userName": "Anna Andersson",
      "customer": "5bb26376c42fb9929932161",
      "customerName": "Company AB",
      "project": "5f924f4f533f103176210",
      "projectName": "Tester",
      "workOrder": "5bae34dca878bd7d0182b",
      "workOrderTitle": "20160525",
      "workOrderNumber": 1181,
      "startAddress": "Östra Gatan 129, Stockholm",
      "endAddress": "Västra Gatan 921, Stockholm",
      "travelPurpose": ".",
      "startOdometer": 156,
      "endOdometer": 178,
      "totalDistance": 22,
      "price": 4,
      "totalAmount": 88,
      "isInvoiced": true,
      "invoice": "5fab29b038bd33301751",
      "modifiedDate": "2016-06-17T09:29:01.958Z",
      "createDate": "2016-06-17T09:20:46.845Z",
      "isInvoiceable": true,
      "timestamp": "2016-06-17T09:20:10.254Z"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves driver journals.

At least one filter, e.g. a date range or a user, has to be specified. A request without any filter returns HTTP status 422 with the code QUERY_TOO_BROAD.

The result is paginated. meta.totalResources is capped at 2000; if there are more matching driver journals, meta.totalResourcesIsExact is false and meta.totalPages is null. Use meta.hasMore and meta.nextPage to fetch the next page.

HTTP Request

GET https://app.seventime.se/api/2/driverJournals

Query Parameters

Parameter Default Description
user If specified, driver journals for the user with this id will be included.
project If specified, driver journals for the project with this id will be included.
customer If specified, driver journals for the customer with this id will be included.
workOrder If specified, driver journals for the work order with this id will be included.
driverJournalItemTypeName If specified, driver journals that match the parameter will be included.
isInvoiceable If specified, driver journals that match the parameter will be included.
workOrderNumber If specified, driver journals that match the parameter will be included.
carRegistrationNumber If specified, driver journals that match the parameter will be included.
startAddress If specified, driver journals that match the parameter will be included.
endAddress If specified, driver journals that match the parameter will be included.
fromDate If specified, driver journals registered after or on this date will be included. The date has to be in the format 'YYYY-MM-DD'
toDate If specified, driver journals registered before or on this date will be included. The date has to be in the format 'YYYY-MM-DD'
sortBy timestamp If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". The sort order will be ascending or descending
limit 100 Number of driver journals per page. Maximum 500
page 1 Page number

Get a specific Driver Journal

curl "https://app.seventime.se/api/2/driverJournals/5613c0eabed93172591b" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/driverJournals/5613c0eabed93172591b";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "isInvoiceable": true,
    "_id": "5613c0eabed93172591b",
    "name": "",
    "driverJournalItemType": "574ed84219e78125333201799",
    "driverJournalItemTypeName": "4 kr/km",
    "car": null,
    "carRegistrationNumber": "ABC123",
    "description": "",
    "user": "5f48eb3e65d7ee40317245d",
    "userName": "Anna Andersson",
    "customer": "5bb26376c42e07412b55",
    "customerName": "Company AB",
    "project": "5f924f4f533f102af784581",
    "projectName": "Tester",
    "workOrder": "5bae34dca878b237942",
    "workOrderTitle": "20160525",
    "workOrderNumber": 1181,
    "startAddress": "Östra Gatan 129, Stockholm",
    "endAddress": "Västra Gatan 921, Stockholm",
    "travelPurpose": ".",
    "startOdometer": 156,
    "endOdometer": 178,
    "totalDistance": 22,
    "price": 4,
    "totalAmount": 88,
    "isInvoiced": true,
    "invoice": "5fab29b0386134897",
    "modifiedDate": "2016-06-17T09:29:01.958Z",
    "createDate": "2016-06-17T09:20:46.845Z",
    "timestamp": "2016-06-17T09:20:10.254Z"
  }
}

This endpoint retrieves a specific driver journal.

HTTP Request

GET https://app.seventime.se/api/2/driverJournals/<_id>

URL Parameters

Parameter Description
_id The _id of the driver journal to retrieve

Get Driver Journals Types

curl "https://app.seventime.se/api/2/driverJournalTypes" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/driverJournalTypes";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "data": [
    {
      "_id": "5e5ef41f03481b466",
      "name": "Diesel - ej skt.fri",
      "articleNumber": "45",
      "cost": 0.5,
      "price": 0.65,
      "isInvoiceable": true,
      "isDefault": false,
      "salaryCompensationType": 20,
      "salaryType": "5e5cd96da2f5b64823791",
      "salaryTypeName": "Milersättning för diesel",
      "createDate": "2020-03-03T09:14:11.750Z",
      "isActive": true,
      "salaryCode": "9172"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves driver journals types.

HTTP Request

GET https://app.seventime.se/api/2/driverJournalTypes

Query Parameters

Parameter Default Description
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending

Create a Driver Journal

curl -X POST "https://app.seventime.se/api/2/driverJournals/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"createdByUser":"512031465648817e55b","user":"5f48eb3e65d7e5489134452","carRegistrationNumber":"ABC123","driverJournalItemType":"5e5ef4124135975","startAddress":"Address start, Stockholm","endAddress":"Address end, Stockholm","travelPurpose":"Delivery","startOdometer":45,"endOdometer":60}'
let jsonData = {
  createdByUser: '512031465648817e55b',
  user: '5f48eb3e65d7e5489134452',
  carRegistrationNumber: 'ABC123',
  driverJournalItemType: '5e5ef4124135975',
  startAddress: 'Address start, Stockholm',
  endAddress: 'Address end, Stockholm',
  travelPurpose: 'Delivery',
  startOdometer: '45',
  endOdometer: '60',
};

let options = {
  url: 'https://app.seventime.se/api/2/driverJournals',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Driver journal created: _id: " + body._id);

  } else {
    console.error("ERROR! Unable to create driver journal: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "isInvoiceable": true,
  "_id": "5fc619b964579133",
  "timestamp": "2020-12-01T10:23:53.370Z",
  "createDate": "2020-12-01T10:23:53.370Z",
  "modifiedDate": "2020-12-01T10:23:53.370Z",
  "user": "5f48eb3e65d7ee457951b",
  "userName": "Anna Andersson",
  "carRegistrationNumber": "ABC123",
  "driverJournalItemType": "5e5ef41f0d5481125",
  "driverJournalItemTypeName": "Diesel - ej skt.fri",
  "startAddress": "Address start, Stockholm",
  "endAddress": "Address end, Stockholm",
  "travelPurpose": "Delivery",
  "startOdometer": 45,
  "endOdometer": 60,
  "totalDistance": 15,
  "isSalaryCompensated": false,
  "price": 0,
  "totalAmount": 0,
  "cost": 0,
  "totalCost": 0
}
"Driver journal created: _id: 5fc619b9625789154"

This endpoint creates a driver journal

HTTP Request

POST https://app.seventime.se/api/2/driverJournals/

POST Parameters

Parameter Type Required? Description
createdByUser String Yes Id of the user who created the driver journal
user String Yes Id of the user on the driver journal
vehicle String Yes* Id of the vehicle. *Required if carRegistrationNumber is not specified
carRegistrationNumber String Yes* Car registration number. *Required if vehicle is not specified. This will not be used if vehicle is specified
driverJournalItemType String Yes Type of trip
startAddress String Yes Start address of the driver journal
endAddress String Yes End address of the driver journal
travelPurpose String Yes Errand/position/Company/Contact person
startOdometer Number Yes Odometer reading at the start
endOdometer Number Yes Odometer reading at the end
customer String No Id of the customer
project String No Id of the project
workOrder String No Id of the work order. If project is specified, the work order must belong to the project. The customer from the work order will be used on the driver journal
price Number No Price/km
cost Number No Cost/km
description String No Description or notes on the driver journal
isInvoiceable Boolean No Is the driver jounal invoiceable? If not specified, this will be set to true
isSalaryCompensated Boolean No Is the driver jounal salary compensated? If not specified, this will be set to false

Update a Driver Journal

curl -X PUT "https://app.seventime.se/api/2/driverJournals/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"5fc619b96294498231","modifiedByUser":"51203146506d96498312567","user":"5f48eb3e65d7ee44598912b"}'
let jsonData = {
  _id: '5fc619b96294735fc7812458',
  modifiedByUser: '51203146506d94891377',
  user: '5f48eb3e65d7ee461288'
};

let options = {
  url: 'https://app.seventime.se/api/2/driverJournals',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Driver journal updated: _id: " + body._id);
  } else {
    console.error("ERROR! Unable to update driver journal: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "isInvoiceable": true,
  "_id": "5fc619b96294735124544bd",
  "timestamp": "2020-12-01T10:23:53.370Z",
  "createDate": "2020-12-01T10:23:53.370Z",
  "modifiedDate": "2020-12-01T10:23:53.370Z",
  "user": "5f48eb3e65d7e2548412d",
  "userName": "Anna Andersson",
  "carRegistrationNumber": "ABC123",
  "driverJournalItemType": "5e5ef41f0d989125e",
  "driverJournalItemTypeName": "Diesel - ej skt.fri",
  "startAddress": "Address start, Stockholm",
  "endAddress": "Address end, Stockholm",
  "travelPurpose": "Delivery",
  "startOdometer": 45,
  "endOdometer": 60,
  "totalDistance": 15,
  "isSalaryCompensated": false,
  "price": 0,
  "totalAmount": 0,
  "cost": 0,
  "totalCost": 0
}
"Driver journal updated: _id: 5fc619b96294735124544bd"

This endpoint updates a driver journal

HTTP Request

PUT https://app.seventime.se/api/2/driverJournals/

PUT Parameters

The table below shows the required fields. Other available fields can be found in the section 'Create a Driver Journal'.

Parameter Type Required? Description
_id String Yes Id of the driver journal
modifiedByUser String Yes Id of the user who made the change
user String Yes Id of the user on the driver journal

Delete a Driver Journal

curl -X DELETE "https://app.seventime.se/api/2/driverJournals/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"5fc619b96294735fd458173","deletedByUser":"51203146506d961c1349691"}'
let jsonData = {
  _id: '5fc619b96294735315489',
  deletedByUser: '51203146506d9611b895'
};

let options = {
  url: 'https://app.seventime.se/api/2/driverJournals',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.delete(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Driver journal deleted: _id: " + body._id);
  } else {
    console.error("ERROR! Unable to delete driver journal: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{
  "_id": "5fc619b96294735fc421d77a",
  "name": ""
}
"Driver journal deleted: _id: 5fc619b962947312234894"

This endpoint deletes a driver journal. A driver journal that has been invoiced or salary processed cannot be deleted.

HTTP Request

DELETE https://app.seventime.se/api/2/driverJournals/

DELETE Parameters

Parameter Type Required? Description
_id String Yes Id of the driver journal
deletedByUser String Yes Id of the user who deleted the driver journal

Expenses

Get Expenses

curl "https://app.seventime.se/api/2/expenses/?limit=2&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/expenses/?limit=2&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 622,
    "totalResourcesIsExact": true,
    "totalPages": 311,
    "currentPage": 1,
    "hasMore": true,
    "nextPage": 2
  },
  "data": [
    {
      "_id": "53ad291839f16d23a6448412b",
      "attestedBy": null,
      "createDate": "2014-06-27T08:11:15.954Z",
      "customer": null,
      "customerName": "",
      "description": "",
      "documents": [],
      "expenseItem": "52d92f32d5fcf8949842b",
      "isAttested": false,
      "isInvoiceable": true,
      "isInvoiced": false,
      "name": "Arbetsordermodul2",
      "numberOfItems": 1,
      "project": "516fad2b265135db7801542b",
      "projectName": "Glimminge",
      "supplementOrder": false,
      "timestamp": "2014-06-27T00:00:00.000Z",
      "totalAmount": 20,
      "totalAmountAfterDiscount": 20,
      "totalAmountInclTax": 25,
      "totalTaxAmount": 5,
      "unit": "st",
      "unitCost": 20,
      "unitPrice": 20,
      "unitPriceInclTax": 25,
      "unitTax": 5,
      "user": "51203146506d9615189d125",
      "userName": "Anna Andersson",
      "workOrder": null,
      "workOrderNumber": 0,
      "workOrderTitle": "",
      "unitPriceAfterDiscount": 20,
      "discountPercent": 0,
      "unitTaxPercent": 25,
      "doReimburse": false,
      "salaryCompilation": null,
      "verificationNumber": "",
      "distributor": null,
      "distributorName": "",
      "totalCost": 20,
      "articleNumber": "208"
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves expenses.

At least one filter, e.g. a date range or a user, has to be specified. A request without any filter returns HTTP status 422 with the code QUERY_TOO_BROAD.

The result is paginated. meta.totalResources is capped at 2000; if there are more matching expenses, meta.totalResourcesIsExact is false and meta.totalPages is null. Use meta.hasMore and meta.nextPage to fetch the next page.

HTTP Request

GET https://app.seventime.se/api/2/expenses

Query Parameters

Parameter Default Description
name If specified, expenses that match the parameter will be included.
articleNumber If specified, expenses that match the parameter will be included.
customer If specified, expenses that match the parameter will be included.
project If specified, expenses that match the parameter will be included.
workOrder If specified, expenses for the work order with this id will be included.
user If specified, expenses registered for the user with this id will be included.
distributor If specified, expenses that match the parameter will be included.
fromDate If specified, expenses registered after or on this date will be included. The date has to be in the format 'YYYY-MM-DD'
toDate If specified, expenses registered before or on this date will be included. The date has to be in the format 'YYYY-MM-DD'
lastModified If specified, expenses that has been modified since the specified timestamp will be included. Accepted formats: 'YYYY-MM-DD', 'YYYY-MM-DD HH:MM', 'YYYY-MM-DD HH:MM:SS', 'YYYY-MM-DDTHH:MM', 'YYYY-MM-DDTHH:MM:SS'
limit 100 Number of expenses per page. Maximum 500
page 1 Page number
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending

Get a specific Expense

curl "https://app.seventime.se/api/2/expenses/53ad291839f16d23a79348b" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/expenses/53ad291839f16d23a79348b";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "_id": "53ad291839f16d23a61549135d",
    "attestedBy": null,
    "createDate": "2014-06-27T08:11:15.954Z",
    "customer": null,
    "customerName": "",
    "description": "",
    "documents": [],
    "expenseItem": "52d92f32d5fc8988645588d",
    "isAttested": false,
    "isInvoiceable": true,
    "isInvoiced": false,
    "name": "Arbetsordermodul2",
    "numberOfItems": 1,
    "project": "516fad2b265135db7803154d",
    "projectName": "Glimminge",
    "supplementOrder": false,
    "timestamp": "2014-06-27T00:00:00.000Z",
    "totalAmount": 20,
    "totalAmountAfterDiscount": 20,
    "totalAmountInclTax": 25,
    "totalTaxAmount": 5,
    "unit": "st",
    "unitCost": 20,
    "unitPrice": 20,
    "unitPriceInclTax": 25,
    "unitTax": 5,
    "user": "51203146506d961c0e1248a25",
    "userName": "Anna Andersson",
    "workOrder": null,
    "workOrderNumber": 0,
    "workOrderTitle": "",
    "unitPriceAfterDiscount": 20,
    "discountPercent": 0,
    "unitTaxPercent": 25,
    "doReimburse": false,
    "salaryCompilation": null,
    "verificationNumber": "",
    "distributor": null,
    "distributorName": "",
    "totalCost": 20,
    "articleNumber": "208"
  }
}

This endpoint retrieves a specific expense.

HTTP Request

GET https://app.seventime.se/api/2/expenses/<_id>

URL Parameters

Parameter Description
_id The _id of the expense to retrieve

Get Expenses Items

curl "https://app.seventime.se/api/2/expenseItems/?limit=10&page=1" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/expenseItems/?limit=10&page=1";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }  
});

The above command returns JSON structured like this:

{
  "meta": {
    "totalResources": 19478,
    "totalPages": 1948,
    "currentPage": 176
  },
  "data": [
    {
      "_id": "5de78aed133271919648552",
      "description": "",
      "tax": 25,
      "articleNumber": "601310",
      "name": "10-pack Reaktionsbollar",
      "unitPrice": 295.59,
      "unitCost": 221,
      "unit": "St",
      "isInvoiceable": true,
      "isCategory": false,
      "parentExpenseItem": null,
      "parentExpenseItemName": "",
      "createDate": "2019-12-04T10:31:06.603Z",
      "bundledArticles": [],
      "alwaysReimburse": false,
      "isActive": true,
      "categoryGroupNumber": "",
      "articleGroupNumber": "",
      "distributor": null,
      "distributorName": "",
      "isInventoryItem": false,
      "unitPriceInclTax": 369.48749999999995
    },
    {
      // ...
    }
  ]
}

This endpoint retrieves expense items.

HTTP Request

GET https://app.seventime.se/api/2/expenseItems

Query Parameters

Parameter Default Description
name If specified, expense items that match the parameter will be included.
articleNumber If specified, expense items that match the parameter will be included.
distributorName If specified, expense items that match the parameter will be included.
description If specified, expense items that match the parameter will be included.
parentExpenseItemName If specified, expense items that match the parameter will be included.
isInvoiceable If specified, expense items that match the parameter will be included.
isActive If specified, expense items that match the parameter will be included.
favorite If specified, expense items that match the parameter will be included.
lastModified If specified, expense items that has been modified since the specified timestamp will be included. Accepted formats: 'YYYY-MM-DD', 'YYYY-MM-DD HH:MM', 'YYYY-MM-DD HH:MM:SS', 'YYYY-MM-DDTHH:MM', 'YYYY-MM-DDTHH:MM:SS'
limit 100 Number of expense items per page. Maximum 500
page 1 Page number
sortBy If specified, a sort will be made on the specified parameter
sortDirection "ascending" or "descending". If specified and sortBy is specified the sort order will be ascending or descending

Get a specific Expense Item

curl "https://app.seventime.se/api/2/expenseItems/5de78aed1332719192366458" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-type: application/json"
/* Sample with the request library */

let url = "https://app.seventime.se/api/2/expenseItems/5de78aed1332719192366458";
let options = {
  url: url,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request(options, function(error, response, body) {
  if (!error && response.statusCode == 200) {
    let info = JSON.parse(body);
    // ...
  } else {
    console.error("Error when calling API! HTTP Code: " + response.statusCode + ", Error message: " + body.errorMessage);
  }
});

The above command returns JSON structured like this:

{
  "data": {
    "_id": "5de78aed1332719192366458",
    "description": "",
    "tax": 25,
    "articleNumber": "601310",
    "name": "10-pack Reaktionsbollar",
    "unitPrice": 295.59,
    "unitCost": 221,
    "unit": "St",
    "isInvoiceable": true,
    "isCategory": false,
    "parentExpenseItem": null,
    "parentExpenseItemName": "",
    "createDate": "2019-12-04T10:31:06.603Z",
    "bundledArticles": [],
    "alwaysReimburse": false,
    "isActive": true,
    "categoryGroupNumber": "",
    "articleGroupNumber": "",
    "distributor": null,
    "distributorName": "",
    "isInventoryItem": false,
    "unitPriceInclTax": 369.48749999999995
  }
}

This endpoint retrieves a specific expense item.

HTTP Request

GET https://app.seventime.se/api/2/expenseItems/<_id>

URL Parameters

Parameter Description
_id The _id of the expense item to retrieve

Create an Expense

curl -X POST "https://app.seventime.se/api/2/expenses/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"createdByUser":"5f48eb3e65d7ee49452154","user":"51203146506d961c0219865121","expenseItem":"5de78aed1332719192366458"}'
let jsonData = {
  createdByUser: '5f48eb3e65d7ee49452154',
  user: '51203146506d961c0219865121',
  expenseItem: '5de78aed1332719192366458'
};

let options = {
  url: 'https://app.seventime.se/api/2/expenses',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.post(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Expense created: _id: " + body._id);
  } else {
    console.error("ERROR! Unable to create expense: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{ 
  "isInvoiceable": true,
  "_id": "5fbe6844166256521851",
  "timestamp": "2020-11-25T14:20:52.129Z",
  "documents": [],
  "createDate": "2020-11-25T14:20:52.129Z",
  "bundledArticles": [],
  "customFields": [],
  "numberOfItems": 1,
  "user": "51203146506d961c0219865121",
  "userName": "Anna Andersson",
  "expenseItem": "5de78aed1332719192366458",
  "articleNumber": "575733",
  "name": "10-pack Reaktionsbollar",
  "description": "Skivhantel av järn",
  "distributor": "573c52cdf609f5692351914b",
  "distributorName": "Lev 4",
  "unit": "St",
  "unitCost": 319,
  "unitTaxPercent": 25,
  "unitPrice": 426.66,
  "unitPriceAfterDiscount": 426.66,
  "discountPercent": 0,
  "unitTax": 106.665,
  "unitPriceInclTax": 533.325,
  "totalTaxAmount": 106.665,
  "totalAmount": 426.66,
  "totalAmountAfterDiscount": 426.66,
  "totalCost": 319,
}
"Expense created: _id: 5fbe6844166256521851"

This endpoint creates an expense

HTTP Request

POST https://app.seventime.se/api/2/expenses/

POST Parameters

Parameter Type Required? Description
createdByUser String Yes Id of the user who created the expense
user String Yes Id of the user on the expense
expenseItem String Yes* Id of the expense item. *Required if freetext for articles is not activated
name String Yes* Name of the article. *Required if expenseItem is not specified. This will set the article to freetext and is only possible if the setting for this is enabled.
workOrder String No Id of the work order
customer String No Id of the customer. If workOrder is specified, the customer from the work order will be used
project String No Id of the project. If workOrder is specified, the project from the work order will be used
distributor String No Id of the distributor
numberOfItems Number No Number of items. If not specified, this will be set to 1
unit String No Unit of the number of items
unitCost Number No* Cost per unit. If not specified, the cost on the expense item will be used. *Required if expenseItem is not specified
unitPrice Number No* Price per unit. If not specified, the price from the price list set on the customer will be used. If no price list is set, the price will be calculated from the cost and the 'Mark up on purchase price' on the customer. If 'Mark up on purchase price' is 0, the price will be set to the expense item price. *Required if expenseItem is not specified
discountPercent Number No* Discount percent on the unit price. *Required if expenseItem is not specified
unitTaxPercent Number No* Tax percent on the unit price. If expenseItem is specified, the tax on the expense item will be used. *Required if expenseItem is not specified
timestamp String No Date of the expense in the format 'YYYY-MM-DD'. If not specified, the current date will be used
description String No Description of the expense
isInvoiceable Boolean No Is the expense invoiceable?
doReimburse Boolean No Is the expense an own expense?

Update an Expense

curl -X PUT "https://app.seventime.se/api/2/expenses/" \
  -H "Client-Secret: thisismysecretkey" \
  -H "Content-Type: application/json" \
  -d '{"_id":"5fbe684416625651d3476852","modifiedByUser":"5f48eb3e612421554796edb","user":"51203146506d961c030689135"}'
let jsonData = {
  _id: '5fbe684416625651d3476852',
  modifiedByUser: '5f48eb3e612421554796edb',
  user: '51203146506d961c030689135'
};

let options = {
  url: 'https://app.seventime.se/api/2/expenses',
  json: jsonData,
  headers: {
    "Client-Secret": "thisismysecretkey",
    "Content-Type": "application/json",
    "Accept": 'application/json'
  }
};

request.put(options, function (error, response, body) {
  if (!error && response.statusCode === 200) {
    console.log(body);
    console.log("Expense updated: _id: " + body._id);
  } else {
    console.error("ERROR! Unable to update expense: " + error);
    console.error(body);
  }
});

The above command returns JSON structured like this:

{ 
[...]
